# Commit message style

Commit messages need to align with the following style:

`<type> (<space>): <change>`

## type
The type of change to be committed.

Possible values:
  - __feature__
  - __fix__
  - __docs__
  - __refactor__

## space
The space that is affected by the commit.

## change
What you've changed. / The actual commit message.

# Examples
- `feature (AHCI): implemented port initialization`
- `fix (processes): changed process spawning to copy the null terminator at the end of the name`
- `refactor (PS/2 keyboard): removed debug logs when handling cursor keys`