# Roadmap

- [x] Bootable system
- [x] Logger
- [x] Page frame manager
- [x] Interrupts
- [x] Page maps
- [x] Heap
- [x] Format strings
- [x] Graphics Renderer
    - [x] Text
    - [x] Double buffering
    - [x] Buffer requests
- [x] Panic Screen
    - [x] Register dump
    - [x] Stack tracing
- [x] Scheduler
    - [x] Threads
    - [x] Processes
- [x] Ramdisk
    - [x] USTAR
    - [x] RAMFS
    - [x] VFS
- [x] ELF loading
- [x] Keyboard input (ps/2 int)
- [x] JSON parser for system config
- [ ] Drivers
    - [X] Loading / Linking into kernel
    - [X] Driver Device assignment (PCI / USB / FS)
    - [ ] API
- [ ] Syscalls
    - [x] Filesystem
    - [x] Memory
    - [ ] Processing
    - [x] Drivers
    - [X] Kernel
- [ ] FAT32 (driver)
- [ ] TUI framework
- [ ] Shell
- [ ] Text Editor
- [ ] TCC
- [ ] Tetris
- [ ] Init System