# color.h

Provides basic color definitions and operations.

# `color_palette_E` - enum
Indexes for g_color_palette. The color palette was designed by [gogh](https://gogh-co.github.io/Gogh/).
- **Grey Dark**
- **Pink**
- **Signal Green**
- **Orange**
- **Blue**
- **Purple**
- **Green**
- **Grey Light**
- **Red**

# `color_argb_T` - struct
| Name  | Type    | Description                     |
|-------|---------|---------------------------------|
| alpha | uint8_t | Transparency value of the color |
| red   | uint8_t | Red value of the color          |
| green | uint8_t | Green value of the color        |
| blue  | uint8_t | Blue value of the color         |

# `color_argb_blend_alpha(background, foreground)` - function (color_argb_T)
Blends **_background_** and **_foreground_** with the _alpha_ value of **_foreground_**.

# `g_color_palette` - global variable
An array of standard colors.
This array is indexed using color_palette_E.
