# stdtypes.h

Standard type definitions, that are used almost everywhere.

#### `uint8_t` - typedef
8-bit wide unsigned int.

Range: `0` - `255`

#### `int8_t` - typedef
8-bit wide signed int.

Range: `-128` - `127`

#### `uint16_t` - typedef
16-bit wide unsigned int.

Range: `0` - `65536`

#### `int16_t` - typedef
16-bit wide signed int.

Range: `-32768` - `32767`

#### `uint32_t` - typedef
32-bit wide unsigned int.

Range: `0` - `4294967296`

#### `int32_t` - typedef
32-bit wide signed int.

Range: `-2147483648` - `2147483647`

#### `uint64_t` - typedef
64-bit wide unsigned int.

Range: `0` - `18446744073709551616`

#### `int64_t` - typedef
64-bit wide signed int.

Range: `-9223372036854775808` - `9223372036854775807`

#### `bool` - typedef
Boolean type, can hold a logical value **true** or **false**.

#### `true` - macro
Logical **true** value.

#### `false` - macro
Logical **false** value

#### `NULL` - macro
A pointer to nowhere.
